=== debian/changelog ===
xtensor (0.23.10-15) unstable; urgency=medium

  * apply MARK_FLAKEY_TEST for i386 in debian/tests (autopkgtest)
  * run clang tests from test-xtensor-clang to get name in CI test log

 -- Drew Parsons <dparsons@debian.org>  Thu, 28 Oct 2021 13:13:11 +0200

xtensor (0.23.10-14) unstable; urgency=medium

  * manage low-memory arches using "-Os -g0"
  * manage mipsel by switching off -march=native
    (cmake -Darch_native_supported=OFF)
    -mxgot is not needed in that case.
    Thanks YunQiang Su and Adrian Bunk for help resolving mipsel.
  * debian patch skip_test_xreducer_average.patch enables failure of
    xreducer.average test to be ignored if MARK_FLAKEY_TEST is defined.
    Used to enable i386 to build. Mark test as "may_fail" rather than
    "skip" to enable the underlying bug to be monitored.
  * override_dh_auto_clean: remove generated html docs

 -- Drew Parsons <dparsons@debian.org>  Thu, 28 Oct 2021 00:50:46 +0200

xtensor (0.23.10-13) unstable; urgency=medium

  * build mipsel with -mxgot (CXXFLAGS and LDFLAGS). Closes: #995867.
  * remove -g build flag on low-memory arches (required for mipsel)

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Oct 2021 05:28:57 +0200

xtensor (0.23.10-12) unstable; urgency=medium

  * restrict xsimd support to strictly those known to work reliably
    (amd64 only, and kfreebsd is untested).  Restrict in debian/tests.

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Oct 2021 13:04:02 +0200

xtensor (0.23.10-11) unstable; urgency=medium

  * drop --no-parallel flag on low-mem arches. Didn't help mipsel.

 -- Drew Parsons <dparsons@debian.org>  Thu, 14 Oct 2021 23:30:54 +0200

xtensor (0.23.10-10) experimental; urgency=medium

  * debian patch badarch_skip_test_xnpy.patch provides cmake option
    BUILD_TEST_XNPY to skip test_xnpy in tests. Required to build
    s390x, hppa, powerpc, ppc64, sparc64. Default BUILD_TEST_XNPY=ON
    for other arches. See Bug#985699.

 -- Drew Parsons <dparsons@debian.org>  Sat, 09 Oct 2021 19:24:22 +0200

xtensor (0.23.10-9) experimental; urgency=medium

  * keep applying -O0 to low-mem arches, needed to avoid virtual memory
    exhausted. Use together with --no-parallel.

 -- Drew Parsons <dparsons@debian.org>  Fri, 08 Oct 2021 09:36:19 +0200

xtensor (0.23.10-8) experimental; urgency=medium

  * drop xsimd hurd-i386 from Build-Depends, not just package Depends.
  * try handling low-mem arches using dh_auto_build --no-parallel
    instead of -O0 (to try to achieve a mipsel build)
  * debian patch doc_sphinx_API.patch updates sphinx API in conf.py to
    fix doc build with sphinx 4.2.
  * wrap doc build in https_proxy=127.0.0.1:9 to ensure build
    independent from network
  * remove mathjax handling. No longer used in docs.

 -- Drew Parsons <dparsons@debian.org>  Fri, 08 Oct 2021 00:30:44 +0200

xtensor (0.23.10-7) experimental; urgency=medium

  * run tests using doctest instead of googletest
    - debian patch doctest_PR2405.patch applies upstream PR2405 to
      convert to doctest
  * debian patch test_test_EXPECT_DOUBLE_EQ_PR2436.patch applies
    upstream PR#2436 (plus test_common_macros.hpp) to use
    EXPECT_DOUBLE_EQ (scalar_near) instead of EXPECT_EQ for tests
    which failed in i386 builds.
  * debian patch test_findpackage_after_project.patch finds packages
    after the test project has been set in tests/CMakeFiles.txt when
    building tests only using installed packages (debian/tests).
    Otherwise there is the error "FindThreads only works if either C or
    CXX language is enabled".
    cf. https://stackoverflow.com/questions/54349824/
  * drop hurd-i386 from list of xsimd arches
    (same problem as i386, x32)

 -- Drew Parsons <dparsons@debian.org>  Mon, 20 Sep 2021 18:49:38 +0200

xtensor (0.23.10-6) experimental; urgency=medium

  * drop arm64, i386, x32 from list of xsimd supported arches.
    See Bug#994246, with upstream xtensor Issue#2433, xsimd Issue#400;
        Bug#994248, with upstream xtensor Issue#2434, xsimd Issue#287.
  * Build tests with -O0 on small-memory arches armel mipsel hurd-i386
    to try to avoid exhausting virtual memory

 -- Drew Parsons <dparsons@debian.org>  Tue, 14 Sep 2021 17:53:20 +0200

xtensor (0.23.10-5) experimental; urgency=medium

  * Build-Depends: python3-sphinx not sphinx-common
    to ensure sphinx-build is available.
  * clean docs only in arch-indep builds
  * use triple-slash with mathjax file reference in docs
  * include xsimd support in debian/tests (autopkgtest)

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Sep 2021 13:23:11 +0200

xtensor (0.23.10-4) experimental; urgency=medium

  * only build docs in arch-indep build
  * Build-Depends-Indep: graphviz
    (provides dot, used when building docs)

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Sep 2021 10:17:19 +0200

xtensor (0.23.10-3) experimental; urgency=medium

  * debian patch xsimd_xcomplex.patch includes xsimd headers with
    xcomplex where available. See upstream Issue#1898.

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Sep 2021 00:38:56 +0300

xtensor (0.23.10-2) experimental; urgency=medium

  * build with XSIMD support on arches where available.
    Build-Depends: libxsimd-dev (>= 7.4.4~)
    [amd64 arm64 i386 hurd-i386 kfreebsd-any m68k sh4 x32]
    (binary package libxtensor-dev Recommends: libxsimd-dev)
  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Mon, 06 Sep 2021 21:14:49 +0300

xtensor (0.23.10-1) experimental; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Fri, 02 Jul 2021 15:31:05 +0200

xtensor (0.23.4-1) experimental; urgency=medium

  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Sat, 10 Apr 2021 10:47:43 +0200

xtensor (0.23.1-2) experimental; urgency=medium

  * bounded Depends: xtl-dev (>= 0.7.0~), xtl-dev (<< 0.8)

 -- Drew Parsons <dparsons@debian.org>  Wed, 17 Mar 2021 01:08:12 +0100

xtensor (0.23.1-1) experimental; urgency=medium

  * New upstream release.

