=== debian/control ===
Source: xtensor
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.1),
 debhelper-compat (= 13),
 dpkg-dev (>= 1.17.14),
 doctest-dev <!nocheck>,
 nlohmann-json3-dev (>= 3.1.1~),
 xtl-dev (>= 0.7.0~), xtl-dev (<< 0.8),
 libxsimd-dev (>= 7.4.4~) [amd64 kfreebsd-any],
 python3-sphinx
Build-Depends-Indep: python3-breathe <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 graphviz <!nodoc>
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/xtensor
Vcs-Git: https://salsa.debian.org/science-team/xtensor.git
Homepage: https://github.com/xtensor-stack/xtensor

Package: libxtensor-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: xtl-dev (>= 0.7.0~), xtl-dev (<< 0.8),
 nlohmann-json3-dev (>= 3.1.1~),
 ${misc:Depends}
Recommends: libxsimd-dev (>= 7.4.4~) [amd64 kfreebsd-any]
Suggests: xtensor-doc <!nodoc>
Breaks: xtensor-dev (<< 0.22.0-4~)
Replaces: xtensor-dev (<< 0.22.0-4~)
Description: multi-dimensional arrays with broadcasting and lazy computing
 xtensor is a C++ library meant for numerical analysis with multi-dimensional
 array expressions.
 .
 xtensor provides:
 .
   - an extensible expression system enabling lazy broadcasting.
   - an API following the idioms of the C++ standard library.
   - tools to manipulate array expressions and build upon xtensor.
 .
 Containers of xtensor are inspired by NumPy, the Python array programming
 library. In fact, xtensor can be used to process numpy data structures inplace
 using Python's buffer protocol. For more details on the numpy bindings, check
 out the xtensor-python project.
 .
 This package provides the header-only library.

Package: xtensor-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for xtensor
 xtensor is a C++ library meant for numerical analysis with multi-dimensional
 array expressions.
 .
 xtensor provides:
 .
   - an extensible expression system enabling lazy broadcasting.
   - an API following the idioms of the C++ standard library.
   - tools to manipulate array expressions and build upon xtensor.
 .
 Containers of xtensor are inspired by NumPy, the Python array programming
 library. In fact, xtensor can be used to process numpy data structures inplace
 using Python's buffer protocol. For more details on the numpy bindings, check
 out the xtensor-python project.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

Package: xtensor-dev
Architecture: all
Section: libdevel
Depends: libxtensor-dev, ${misc:Depends}
Description: multi-dimensional arrays with broadcasting (transition package)
 xtensor is a C++ library meant for numerical analysis with multi-dimensional
 array expressions.
 .
 This is a dummy package transitioning to libxtensor-dev.
