=== debian/tests/control ===
Tests: test-xtensor
Depends: cmake,
         g++,
         doctest-dev,
         libxtensor-dev,
         libxsimd-dev (>= 7.4.4~) [amd64 kfreebsd-any]
Restrictions: allow-stderr

Tests: test-xtensor-clang
Depends: clang,
         cmake,
         doctest-dev,
         libxtensor-dev,
         libxsimd-dev (>= 7.4.4~) [amd64 kfreebsd-any]
Restrictions: allow-stderr
